#ifndef __BOS_SYNCHRONIZATIONEXCEPTION_H__
#define __BOS_SYNCHRONIZATIONEXCEPTION_H__

//TO_BE_EXPORTED
#include "bOS.h"
#include "bOSException.h"

namespace bOS
{
    namespace Exception
    {
        #define NO_MUTEX_AVAILABLE      "The system lacked the necessary resources (other than memory) to initialize another mutex."
		#define NO_SEMAPHORE_AVAILABLE	"The system ..."

        class BOS_API SynchronizationException : public BaseException
        {
            public:

                SynchronizationException(const String & message ): BaseException( message ) {}

                SynchronizationException() : BaseException( NO_MUTEX_AVAILABLE ) {}

                SynchronizationException( const String & message, const int lineNumber )
                    : BaseException(message, lineNumber) {}

                virtual ~SynchronizationException() {}
        };
    }
};

#endif


