using System;
using System.Xml;
using System.Collections;

namespace Scenario.WorkflowEngine.DataModel.Common
{
	//*********************************************************************
	//
	// ExtendedAttribute Class
	//
	// toto : inserire l'esatta descrizione di ci che fa l'oggetto
	//
	//*********************************************************************

	public class XMLExtendedAttribute : bOS.XML.Data.XMLObject 
	{
		public const string MAIN_NODE	= "ExtendedAttribute";

		private const string NAME_ATTRIBUTE	= "Name";
		private const string VALUE_ATTRIBUTE= "Value";

		/** FIELDS **/

		private string sName;
		private string sValue;

		public string sInnerValue;

		/** CONSTRUCTORS **/

		/** CONSTRUCTOR Width simple Property **/
		public XMLExtendedAttribute()
		{
			this.Init();
		}

		/** CONSTRUCTOR Width xml parsering**/
		public XMLExtendedAttribute(System.Xml.XmlNode node)
		{
			this.Parse(node);
		}

		/** CONSTRUCTOR Width xml Values **/
		public XMLExtendedAttribute(string _Name, string _Value)
		{
			sName = _Name;
			sValue = _Value;
		}

		/** PROPERTIES **/


		public string Name 
		{
			get { return sName; }
			set { sName = value; }

		}

		public string InnerValue 
		{
			get { return sInnerValue; }
			set { sInnerValue = value; }

		}

		public string Value 
		{
			get { return sValue; }
			set { sValue = value; }

		}

		override public void Init()
		{
			sName= string.Empty;
			sValue= string.Empty;
			sInnerValue= string.Empty;
		}

		/** INSTANCE METHODS **/

		/** Parsering method to fill the object **/
		override public void Parse(System.Xml.XmlNode node2Parse)
		{
			System.Xml.XmlNode node;

			/** find the attributes situated on the root tag **/
			for ( int i=0; i<node2Parse.Attributes.Count;i++)
			{
				node = node2Parse.Attributes.Item(i);
				switch ( node.Name ) 
				{
					case XMLExtendedAttribute.NAME_ATTRIBUTE:
						sName = node.InnerText;
						break;
					case XMLExtendedAttribute.VALUE_ATTRIBUTE:
						sValue = node.InnerText;
						break;
				}
			}

			sInnerValue = node2Parse.InnerText;
		}

		/**Method to retive a node from object **/
		override public bOS.XML.XMLNode GetXMLNode()
		{
			bOS.XML.XMLNode xmlNode = new bOS.XML.XMLNode(XMLExtendedAttribute.MAIN_NODE);
			xmlNode.AddAttribute ( new bOS.XML.XMLAttribute ( XMLExtendedAttribute.NAME_ATTRIBUTE, sName) );
			xmlNode.AddAttribute ( new bOS.XML.XMLAttribute ( XMLExtendedAttribute.VALUE_ATTRIBUTE, sValue) );

			xmlNode.SetValue ( sInnerValue );
			
			return xmlNode;
		}
	}
}