using System;

namespace Scenario.WorkflowEngine.DataModel.WorkflowParticipantsData
{
	//*********************************************************************
	//
	// Role Class
	//
	// toto : inserire l'esatta descrizione di ci che fa l'oggetto
	//
	//*********************************************************************
	public class XMLRole : bOS.XML.Data.XMLObject 
	{
		public const string MAIN_NODE			= "Role";

		private const string KEY_ATTRIBUTE		= "Key";
		private const string NAME_NODE			= "Name";
		private const string DESCRIPTION_NODE	= "Description";

		/** FIELDS **/

		private string sKey;
		private string sName;
		private string sDescription;

		private XMLUsers vUsers;

		/** CONSTRUCTORS **/

		/** CONSTRUCTOR Width simple Property **/
		public XMLRole()
		{
			this.Init();
		}


		/** CONSTRUCTOR Width xml parsering**/
		public XMLRole(System.Xml.XmlNode node)
		{
			Parse(node);
		}

		/** CONSTRUCTOR Width xml Values **/
		public XMLRole(string _key, string _name)
		{
			this.Init();

			sKey = _key;
			sName = _name;
		}

		/** PROPERTIES **/

		public XMLUsers XMLUsers 
		{
			get { return vUsers; }
			set { vUsers = value; }
		}

		public string Name 
		{
			get { return sName; }
			set { sName = value; }
		}

		public string Key 
		{
			get { return sKey; }
			set { sKey = value; }
		}

		public string Description 
		{
			get { return sDescription; }
			set { sDescription = value; }
		}

		/** INSTANCE METHODS **/

		override public void Init()
		{
			sKey = string.Empty;
			sName = string.Empty;
			sDescription = string.Empty;

			vUsers = new XMLUsers();
		}

		/** Parsering method to fill the object **/
		override public void Parse(System.Xml.XmlNode node2Parse)
		{
			this.Init();

			System.Xml.XmlNode node;
			/** find the attributes situated on the root tag **/

			for ( int i=0; i<node2Parse.Attributes.Count; i++)
			{
				node= node2Parse.Attributes.Item(i);

				switch (node.Name)
				{
					case XMLRole.KEY_ATTRIBUTE:
						sKey = node.InnerText;
						break;
				}
			}

			/** find the attributes situated on sub tags **/
			for ( int i=0; i<node2Parse.ChildNodes.Count; i++)
			{
				node = node2Parse.ChildNodes[i];

				switch ( node.Name )
				{
					case XMLRole.NAME_NODE:
						sName=node.InnerText;
						break;

					case XMLRole.DESCRIPTION_NODE:
						sDescription=node.InnerText;
						break;

					case XMLUsers.MAIN_NODE:
						vUsers.Parse(node);
						break;
				}
			}
		}

		/**Method to retive a node from object **/
		override public bOS.XML.XMLNode GetXMLNode()
		{
			bOS.XML.XMLNode xmlNode = new bOS.XML.XMLNode(XMLRole.MAIN_NODE);
			xmlNode.AddAttribute ( new bOS.XML.XMLAttribute ( XMLRole.KEY_ATTRIBUTE, sKey) );
			xmlNode.AddNode ( new bOS.XML.XMLNode (XMLRole.NAME_NODE, sName) );
			xmlNode.AddNode ( new bOS.XML.XMLNode (XMLRole.DESCRIPTION_NODE, sDescription) );

			xmlNode.AddNode ( vUsers.GetXMLNode() );
			
			return xmlNode;
		}	
	}
}