using System;
using Scenario.WorkflowEngine.DataModel;

namespace Scenario.WorkflowEngine.DataModel.WorkflowApplicationsData
{
	//*********************************************************************
	//
	// ApplicationFunctionResult Class
	//
	// toto : inserire l'esatta descrizione di ci che fa l'oggetto
	//
	//*********************************************************************
	public class XMLApplicationFunctionResult : bOS.XML.Data.XMLObject
	{
		public const string MAIN_NODE = "Result";

		private const string CODE_ATTRIBUTE = "Code";
		private const string MESSAGE_NODE	= "Message";

		/** FIELDS **/

		private int iCode;
		private string sMessage;

		private Common.XMLFormalParameters vParameters;

		/** CONSTRUCTORS **/

		/** CONSTRUCTOR Width simple Property **/
		public XMLApplicationFunctionResult()
		{
			this.Init();
		}

		/** CONSTRUCTOR Width xml parsering**/
		public XMLApplicationFunctionResult(System.Xml.XmlNode node2Parse)
		{
			this.Parse(node2Parse);
		}

		/** PROPERTIES **/


		public int Code 
		{
			get { return iCode; }
			set { iCode = value; }

		}

		public string Message 
		{
			get { return sMessage; }
			set { sMessage = value; }

		}

		public Common.XMLFormalParameters XMLFormalParameters 
		{
			get { return vParameters; }
			set { vParameters = value; }
		}

		/** INSTANCE METHODS **/

		public override void Init()
		{
			vParameters = new Common.XMLFormalParameters();
		}

		/** Parsering method to fill the object **/
		override public void Parse(System.Xml.XmlNode node2Parse)
		{
			System.Xml.XmlNode node;

			/** find the attributes situated on the root tag **/
			for ( int i=0; i<node2Parse.Attributes.Count; i++)
			{
				node= node2Parse.Attributes.Item(i);

				switch (node.Name)
				{
					case XMLApplicationFunctionResult.CODE_ATTRIBUTE:
						iCode = Int32.Parse (node.InnerText);
						break;
				}
			}

			/** find the attributes situated on sub tags **/
			for ( int i=0; i<node2Parse.ChildNodes.Count; i++)
			{
				node = node2Parse.ChildNodes[i];

				switch ( node.Name )
				{
					case Common.XMLFormalParameters.MAIN_NODE:
						vParameters.Parse(node);
						break;
					case XMLApplicationFunctionResult.MESSAGE_NODE:
						sMessage = node.InnerText;
						break;

				}
			}
		}

		/**Method to retive a node from object **/
		override public bOS.XML.XMLNode GetXMLNode()
		{
			bOS.XML.XMLNode xmlNode = new bOS.XML.XMLNode(XMLApplicationFunctionResult.MAIN_NODE);
			xmlNode.AddAttribute ( new bOS.XML.XMLAttribute ( XMLApplicationFunctionResult.CODE_ATTRIBUTE, iCode));
			xmlNode.AddNode ( new bOS.XML.XMLNode ( XMLApplicationFunctionResult.MESSAGE_NODE, sMessage));

			xmlNode.AddNode ( vParameters.GetXMLNode() );

			return xmlNode;
		}
	}
}