using System;
using Scenario.WorkflowEngine.DataModel;

namespace Scenario.WorkflowEngine.DataModel.WorkflowParticipantsData
{
	//*********************************************************************
	//
	// User Class
	//
	// toto : inserire l'esatta descrizione di ci che fa l'oggetto
	//
	//*********************************************************************
	public class XMLUser : bOS.XML.Data.XMLObject
	{
		public const string MAIN_NODE = "User";

		private const string KEY_ATTRIBUTE		= "Key";
		private const string PASSWORD_NODE		= "Password";
		private const string NAME_NODE			= "Name";
		private const string DESCRIPTION_NODE	= "Description";
		private const string DISPLAYNAME_NODE	= "DisplayName";
		private const string EMAIL_NODE			= "Email";

		/** FIELDS **/

		private string sKey;
		private string sPassword;
		private string sName;
		private string sDescription;
		private string sDisplayName;
		private string sEmail;

		/** CONSTRUCTORS **/

		/** CONSTRUCTOR Width simple Property **/
		public XMLUser()
		{
			this.Init();
		}

		/** CONSTRUCTOR Width xml Values **/
		public XMLUser(string _key, string _name, string _password)
		{
			this.Init();

			sKey = _key;
			sPassword = _password;
		}

		/** CONSTRUCTOR Width xml parsering**/
		public XMLUser(System.Xml.XmlNode node)
		{
			Parse(node);
		}

		/** PROPERTIES **/


		public string Name 
		{
			get { return sName; }
			set { sName = value; }
		}

		public string Key 
		{
			get { return sKey; }
			set { sKey = value; }
		}

		public string Password 
		{
			get { return sPassword; }
			set { sPassword = value; }
		}

		public string Description 
		{
			get { return sDescription; }
			set { sDescription = value; }
		}

		public string DisplayName 
		{
			get { return sDisplayName; }
			set { sDisplayName = value; }
		}

		public string Email 
		{
			get { return sEmail; }
			set { sEmail = value; }
		}

	    /** INSTANCE METHODS **/

		override public void Init()
		{
			sKey = string.Empty;
			sPassword = string.Empty;
			sName = string.Empty;
			sDescription = string.Empty;
			sDisplayName = string.Empty;
			sEmail= string.Empty;
		}

		/** Parsering method to fill the object **/
		override public void Parse(System.Xml.XmlNode node2Parse)
		{
			this.Init();

			System.Xml.XmlNode node;

			/** find the attributes situated on the root tag **/

			for ( int i=0; i<node2Parse.Attributes.Count; i++)
			{
				node= node2Parse.Attributes.Item(i);

				switch (node.Name)
				{
					case XMLUser.KEY_ATTRIBUTE:
						sKey = node.InnerText;
						break;
				}
			}
					 
			/** find the attributes situated on sub tags **/
			for ( int i=0; i<node2Parse.ChildNodes.Count; i++)
			{
				node = node2Parse.ChildNodes[i];

				switch ( node.Name) 
				{
					case XMLUser.NAME_NODE:
						sName=node.InnerText;
						break;

					case XMLUser.DESCRIPTION_NODE:
						sDescription=node.InnerText;
						break;

					case XMLUser.PASSWORD_NODE:
						sPassword=node.InnerText;
						break;

					case XMLUser.EMAIL_NODE:
						sEmail=node.InnerText;
						break;

					case XMLUser.DISPLAYNAME_NODE:
						sDisplayName=node.InnerText;
						break;
				}
			}
		}

		/**Method to retive a node from object **/
		override public bOS.XML.XMLNode GetXMLNode()
		{
			bOS.XML.XMLNode xmlNode = new bOS.XML.XMLNode(XMLUser.MAIN_NODE);
			xmlNode.AddAttribute ( new bOS.XML.XMLAttribute ( XMLUser.KEY_ATTRIBUTE, sKey) );
			xmlNode.AddNode ( new bOS.XML.XMLNode (XMLUser.NAME_NODE, sName) );
			xmlNode.AddNode ( new bOS.XML.XMLNode (XMLUser.DESCRIPTION_NODE, sDescription) );
			xmlNode.AddNode ( new bOS.XML.XMLNode (XMLUser.PASSWORD_NODE, sPassword) );
			xmlNode.AddNode ( new bOS.XML.XMLNode (XMLUser.EMAIL_NODE, sEmail) );
			xmlNode.AddNode ( new bOS.XML.XMLNode (XMLUser.DISPLAYNAME_NODE, sDisplayName) );
			
			return xmlNode;
		}
	}
}