using System;
using System.Collections;
using Scenario.WorkflowEngine.DataModel;

namespace Scenario.WorkflowEngine.DataModel.WorkflowProcesses
{
	//*********************************************************************
	//
	// XmlVariables Class
	//
	// The XmlVariables class represents a collection base of XmlVariable
	// Its imports methods from WAPI.XmlObjectSet like get set and add
	// XmlVariables Has no fields
	//
	//*********************************************************************

	public class XMLReports : bOS.XML.Data.XMLObjectSet
	{
		public const string MAIN_NODE		= "Reports";

		/** FIELDS **/

		/** no fields **/

		/** CONSTRUCTORS **/

		/** CONSTRUCTOR Empty **/
		public XMLReports()
		{
			this.Init();
		}

		/** CONSTRUCTOR Width xml parsering**/
		public XMLReports(System.Xml.XmlNode nodeList)
		{
			this.Parse (nodeList);
		}

		/** INSTANCE METHODS **/

		public override void Init()
		{
			this.RemoveAll();
		}

		override public void Parse(System.Xml.XmlNode nodeList)
		{
			this.Init();

			System.Xml.XmlNode node;

			for ( int i=0; i<nodeList.ChildNodes.Count;i++)
			{
				node = nodeList.ChildNodes[i];

				switch ( node.Name) 
				{
					case XMLReport.MAIN_NODE:
						this.Add ( new XMLReport(node));
						break;
				}
			}
		}

		override public bOS.XML.XMLNode GetXMLNode()
		{
			bOS.XML.XMLNode xmlNode = new bOS.XML.XMLNode(XMLReports.MAIN_NODE);

			for ( int i=0; i<this.Count;i++)
			{
				xmlNode.AddNode ( this[i].GetXMLNode() );
			}

			return xmlNode;
		}

		/** SORTING  FIELDS **/

		public enum SortFields 
		{
			Date,
			Text
		}

		/** SORTING METHODS **/


		public void Sort(SortFields sortField, bool isAscending) 
		{
			switch (sortField) 
			{
				case SortFields.Date:
					InnerList.Sort(new DateComparer());
					break;
				case SortFields.Text:
					InnerList.Sort(new TextComparer());
					break;
				
			}
			if (!isAscending) InnerList.Reverse();
		}


		private sealed class DateComparer : IComparer 
		{
			public int Compare(object x, object y) 
			{
				XMLReport first = (XMLReport) x;
				XMLReport second = (XMLReport) y;
				return first.Date.CompareTo(second.Date);
			}
		}

		private sealed class TextComparer : IComparer 
		{
			public int Compare(object x, object y) 
			{
				XMLReport first = (XMLReport) x;
				XMLReport second = (XMLReport) y;
				return first.Text.CompareTo(second.Text);
			}
		}

		
	}
}
