﻿#region Imports Directives

using System;
using System.Collections.Generic;
using System.Text;
using Quartz;
using log4net;
using Scenario.WorkflowEngine.Scheduler.Data;
using Scenario.WorkflowEngine.DataBase;
using System.Collections;


#endregion

namespace Scenario.WorkflowEngine.Scheduler.Jobs
{
    public class ListenerJob : Quartz.IJob
    {
        #region Variables
        private static ILog _log = LogManager.GetLogger(typeof(ListenerJob));

       
        #endregion

        #region Constructor

        public ListenerJob()
        {
        }

        #endregion

        void Quartz.IJob.Execute(Quartz.JobExecutionContext context)
        {
            bool bJobRunning  = JobController.Instance().AddJob(context.JobDetail.Name);
            if ( !bJobRunning)
                return;
            
            IList items = Helpers.ExchangeItem().SelectItemToWork();
            IEnumerator enumerator = items.GetEnumerator();
            enumerator.Reset();
            while ( enumerator.MoveNext () )
            {
                ExchangeItem item = (ExchangeItem)enumerator.Current;

                Scenario.WorkflowEngine.Events.EventBase _event = 
                    Scenario.WorkflowEngine.Events.EventsFactory.MakeEvent(item.Object);

                Trigger trigger = _event.GetTrigger(item.ProcessXML);
                trigger.Name = String.Format("Trigger_{0}", item.Id);

                JobDetail jobDetail = _event.GetJobDetail(item.ProcessXML);
                jobDetail.Name= String.Format("Activity_{0}", item.Id);

                try
                {
                    context.Scheduler.ScheduleJob(jobDetail, trigger);
                    Helpers.ExchangeItem().MarkAsWorked(item.Id);
                }
                catch (Exception err)
                {
                    System.Console.Error.WriteLine(err.Message);
                }
            }

            JobController.Instance().RemoveJob(context.JobDetail.Name);

        }
    }
}
