﻿
#region Imports Directives

using System;
using System.Collections.Generic;
using System.Text;
using Quartz;
using log4net;

#endregion

namespace Scenario.WorkflowEngine.Events.Jobs
{
    public class SingalJob : ScenarioJob
    {

        public override void Run(Quartz.JobExecutionContext context)
        {
            context.Scheduler.PauseTrigger(context.Trigger.Name, "Scenario");
            System.Console.Out.WriteLine(string.Format("{0} Signal", DateTime.Now.ToLongTimeString()));
            StringBuilder processId = new StringBuilder(100);
            WAPI.Response wapiResponse = new WAPI.Response();
            System.Console.Out.WriteLine("Create Process [StartEnd]");
            WAPI.ProcessHelper.CreateProcessInstance("StartEnd", processId, ref wapiResponse);
            if (wapiResponse.iCode == 0)
            {
                System.Console.Out.WriteLine("Process {0} created", processId);
            }
            else
            {
                System.Console.Out.WriteLine("Impossible to create Process");
                context.Scheduler.ResumeTrigger(context.Trigger.Name, "Scenario");
                return;
            }

            WAPI.ProcessHelper.StartProcessInstance(processId.ToString(), ref wapiResponse);
            if (wapiResponse.iCode == 0)
            {
                System.Console.Out.WriteLine("Process {0} started", processId);
            }
            else
            {
                System.Console.Out.WriteLine("Impossible to start Process");
                context.Scheduler.ResumeTrigger(context.Trigger.Name, "Scenario");
                return;
            }
            context.Scheduler.DeleteJob(context.JobDetail.Name, "Scenario");
        }

    }
}
