using System;

using Scenario.WorkflowEngine.DataModel.WorkflowParticipantsData;

namespace Scenario.WAPI
{
	/// <summary>
	/// Descrizione di riepilogo per wrpWAPIActivity.
	/// </summary>
	public partial class UserHelper
	{
		/// <summary>
		/// Initializes a new instance  of the <see cref="User"/> class.
		/// </summary>
        public UserHelper()
		{
		}

        /// <summary>
        /// Gets the users.
        /// </summary>
        /// <returns></returns>
        public XMLUsers GetUsers()
        {
            Response response = new Response();

            string sUsers = UserHelper.GetUsers(ref response);

            if (response.iCode != 0)
                throw new Exception.WAPIException(response.iCode, response.sMsg);

            XMLUsers xmlUsers = new XMLUsers();
            xmlUsers.Parse(sUsers);

            return xmlUsers;
        }

        public Boolean Authenticate(String userId, String password)
        {
            Response response = new Response();
            int iAuthenticate = UserHelper.Authenticate(userId, password, ref response);

            if (response.iCode != 0)
                throw new Exception.WAPIException(response);

            if (iAuthenticate == 0)
                return false;
            else
                return true;
        }
	}
}
