using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

using Scenario.WorkflowEngine.DataModel.Common;
using Scenario.WorkflowEngine.DataModel.WorkflowApplicationsData;
using WorkflowRelevantData = Scenario.WorkflowEngine.DataModel.WorkflowRelevantData;

namespace Scenario.Modeler
{
	/// <summary>
	/// Descrizione di riepilogo per Form1.
	/// </summary>
	public class FormApplications : System.Windows.Forms.Form
	{
		private System.Windows.Forms.GroupBox groupBox1;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.ComboBox cmbApplications;
		/// <summary>
		/// Variabile di progettazione necessaria.
		/// </summary>
		private System.ComponentModel.Container components = null;
		private System.Windows.Forms.ListView listFunctions;
		private System.Windows.Forms.ListView listParametersIn;
		private System.Windows.Forms.ListView listParametersOut;

		XMLApplications vApplications = null;
		XMLApplication applicationSelected = null;
		WorkflowRelevantData.XMLAttributes vAttributes = null;
		private System.Windows.Forms.Panel panel2;
		private System.Windows.Forms.Button btnCancel;
		private System.Windows.Forms.Button btnSave;
		private System.Windows.Forms.Label label2;

		public XMLApplicationFunction xmlApplicationFunction = null;

		public FormApplications()
		{
			//
			// Necessario per il supporto di Progettazione Windows Form
			//
			InitializeComponent();

			//
			// TODO: aggiungere il codice del costruttore dopo la chiamata a InitializeComponent
			//
            WAPI.ApplicationHelper helper = new WAPI.ApplicationHelper();
			vApplications = helper.GetApplications();
			for ( int i=0; i<vApplications.Count; i++)
			{
				XMLApplication application = (XMLApplication) vApplications[i];

				cmbApplications.Items.Add ( application.Name );
			}
		}

		public FormApplications(XMLApplicationFunction xmlFunction) : this()
		{
			this.cmbApplications.Text = xmlFunction.Application;

			this.FillFunctionsList (xmlFunction.Application);

			for ( int i=0;i<listFunctions.Items.Count;i++)
			{
				if ( listFunctions.Items[i].SubItems[0].Text == xmlFunction.Name ) 
				{
					listFunctions.Items[i].Selected = true;
				}
			}
			this.FillListWithParameters(listParametersIn, xmlFunction.XMLFormalParameters, false);
			this.FillListWithParameters(listParametersOut, xmlFunction.XMLApplicationFunctionResult.XMLFormalParameters, true);
			
		}

		public WorkflowRelevantData.XMLAttributes XMLAttributes 
		{
			set { vAttributes = value; }
		}

		/// <summary>
		/// Pulire le risorse in uso.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Codice generato da Progettazione Windows Form
		/// <summary>
		/// Metodo necessario per il supporto della finestra di progettazione. Non modificare
		/// il contenuto del metodo con l'editor di codice.
		/// </summary>
		private void InitializeComponent()
		{
			this.listFunctions = new System.Windows.Forms.ListView();
			this.groupBox1 = new System.Windows.Forms.GroupBox();
			this.label1 = new System.Windows.Forms.Label();
			this.cmbApplications = new System.Windows.Forms.ComboBox();
			this.listParametersIn = new System.Windows.Forms.ListView();
			this.listParametersOut = new System.Windows.Forms.ListView();
			this.panel2 = new System.Windows.Forms.Panel();
			this.btnCancel = new System.Windows.Forms.Button();
			this.btnSave = new System.Windows.Forms.Button();
			this.label2 = new System.Windows.Forms.Label();
			this.groupBox1.SuspendLayout();
			this.panel2.SuspendLayout();
			this.SuspendLayout();
			// 
			// listFunctions
			// 
			this.listFunctions.HeaderStyle = System.Windows.Forms.ColumnHeaderStyle.None;
			this.listFunctions.Location = new System.Drawing.Point(10, 185);
			this.listFunctions.MultiSelect = false;
			this.listFunctions.Name = "listFunctions";
			this.listFunctions.Size = new System.Drawing.Size(355, 369);
			this.listFunctions.Sorting = System.Windows.Forms.SortOrder.Ascending;
			this.listFunctions.TabIndex = 2;
			this.listFunctions.View = System.Windows.Forms.View.Details;
			this.listFunctions.ItemActivate += new System.EventHandler(this.listFunctions_ItemActivate);
			// 
			// groupBox1
			// 
			this.groupBox1.Controls.Add(this.label1);
			this.groupBox1.Controls.Add(this.cmbApplications);
			this.groupBox1.Location = new System.Drawing.Point(10, 9);
			this.groupBox1.Name = "groupBox1";
			this.groupBox1.Size = new System.Drawing.Size(558, 157);
			this.groupBox1.TabIndex = 3;
			this.groupBox1.TabStop = false;
			this.groupBox1.Text = "Applications";
			// 
			// label1
			// 
			this.label1.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.label1.Location = new System.Drawing.Point(10, 65);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(537, 83);
			this.label1.TabIndex = 2;
			this.label1.Text = "A brief description. Add in Application DataModel";
			// 
			// cmbApplications
			// 
			this.cmbApplications.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
			this.cmbApplications.Location = new System.Drawing.Point(10, 28);
			this.cmbApplications.Name = "cmbApplications";
			this.cmbApplications.Size = new System.Drawing.Size(537, 24);
			this.cmbApplications.Sorted = true;
			this.cmbApplications.TabIndex = 1;
			this.cmbApplications.SelectedIndexChanged += new System.EventHandler(this.cmbApplications_SelectedIndexChanged);
			// 
			// listParametersIn
			// 
			this.listParametersIn.Location = new System.Drawing.Point(376, 185);
			this.listParametersIn.Name = "listParametersIn";
			this.listParametersIn.Size = new System.Drawing.Size(776, 203);
			this.listParametersIn.TabIndex = 6;
			this.listParametersIn.View = System.Windows.Forms.View.Details;
			this.listParametersIn.ItemActivate += new System.EventHandler(this.listParametersIn_ItemActivate);
			// 
			// listParametersOut
			// 
			this.listParametersOut.Location = new System.Drawing.Point(374, 397);
			this.listParametersOut.Name = "listParametersOut";
			this.listParametersOut.Size = new System.Drawing.Size(778, 157);
			this.listParametersOut.Sorting = System.Windows.Forms.SortOrder.Ascending;
			this.listParametersOut.TabIndex = 7;
			this.listParametersOut.View = System.Windows.Forms.View.Details;
			this.listParametersOut.ItemActivate += new System.EventHandler(this.listParametersOut_ItemActivate);
			// 
			// panel2
			// 
			this.panel2.Controls.Add(this.btnCancel);
			this.panel2.Controls.Add(this.btnSave);
			this.panel2.Dock = System.Windows.Forms.DockStyle.Bottom;
			this.panel2.Location = new System.Drawing.Point(0, 563);
			this.panel2.Name = "panel2";
			this.panel2.Size = new System.Drawing.Size(1160, 56);
			this.panel2.TabIndex = 15;
			// 
			// btnCancel
			// 
			this.btnCancel.Location = new System.Drawing.Point(432, 8);
			this.btnCancel.Name = "btnCancel";
			this.btnCancel.Size = new System.Drawing.Size(72, 40);
			this.btnCancel.TabIndex = 10;
			this.btnCancel.Text = "Cancel";
			this.btnCancel.Click += new System.EventHandler(this.btnCancel_Click);
			// 
			// btnSave
			// 
			this.btnSave.Location = new System.Drawing.Point(344, 8);
			this.btnSave.Name = "btnSave";
			this.btnSave.Size = new System.Drawing.Size(80, 40);
			this.btnSave.TabIndex = 9;
			this.btnSave.Text = "Save";
			this.btnSave.Click += new System.EventHandler(this.btnSave_Click);
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(624, 16);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(352, 128);
			this.label2.TabIndex = 16;
			this.label2.Text = "Non  possibile ordinare la lista dei parametri in quanto sarebbero passati con l" +
				"\'ordine sbagliato alle application di tipo EXE";
			// 
			// FormApplications
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(6, 15);
			this.ClientSize = new System.Drawing.Size(1160, 619);
			this.Controls.Add(this.label2);
			this.Controls.Add(this.panel2);
			this.Controls.Add(this.listParametersOut);
			this.Controls.Add(this.listParametersIn);
			this.Controls.Add(this.groupBox1);
			this.Controls.Add(this.listFunctions);
			this.Name = "FormApplications";
			this.Text = "Application";
			this.groupBox1.ResumeLayout(false);
			this.panel2.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		private void cmbApplications_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			this.FillFunctionsList ((string)cmbApplications.SelectedItem);
		}

		private void FillFunctionsList(string sApplicationName)
		{
			listFunctions.Clear();

			ColumnHeader column = new ColumnHeader();
			column.Text = "Funzioni";
			column.Width = listFunctions.Width ;
			listFunctions.Columns.Add ( column);

			XMLApplication application = null;
			try
			{
				application = vApplications.Get ( sApplicationName );
				applicationSelected = application;
			}
			catch ( Scenario.WorkflowEngine.DataModel.Exception.ApplicationNotFound) 
			{
				MessageBox.Show ("Impossible to retrieve Application fatures.");
				return;
			}

			for ( int i=0; i<application.XMLApplicationFunctions.Count; i++)
			{
				XMLApplicationFunction function = (XMLApplicationFunction)application.XMLApplicationFunctions[i];

				ListViewItem item = new ListViewItem( new string[] { function.Name });

				listFunctions.Items.Add ( item);
			}
		}


		private void FillListWithParameters( ListView list, XMLFormalParameters vParameters, bool bBind )
		{
			list.Clear();
			list.Columns.Add("Name",(list.Width-150)/2, HorizontalAlignment.Left);
			list.Columns.Add("Type",100, HorizontalAlignment.Left);
			list.Columns.Add("Mandatory",50, HorizontalAlignment.Left);
			list.Columns.Add("Bind",(list.Width-150)/2, HorizontalAlignment.Left);

			for ( int i=0; i<vParameters.Count; i++)
			{
				XMLFormalParameter parameter = (XMLFormalParameter)vParameters[i];

				ListViewItem item =null;
				if ( bBind )
				{
					item = new ListViewItem( new string[] { parameter.Name, parameter.Type, parameter.Mandatory ? "YES" : "NO","[" + parameter.Bind + "]"});
				}
				else
				{
					item = new ListViewItem( new string[] { parameter.Name, parameter.Type, parameter.Mandatory ? "YES" : "NO",parameter.Value});
				}

				list.Items.Add (item);
			}
		}

		private void listFunctions_ItemActivate(object sender, System.EventArgs e)
		{
			if ( listFunctions.SelectedItems.Count == 0 )
			{
				return;
			}

			string sFunction = listFunctions.SelectedItems[0].SubItems[0].Text;

			XMLApplicationFunction function = (XMLApplicationFunction)applicationSelected.XMLApplicationFunctions.Get (sFunction);

			this.FillListWithParameters ( listParametersIn, function.XMLFormalParameters, false);
			this.FillListWithParameters ( listParametersOut, function.XMLApplicationFunctionResult.XMLFormalParameters, true);
		
		}

		private void listParametersIn_ItemActivate(object sender, System.EventArgs e)
		{
			AssignParameter frmAssign = new AssignParameter();
			frmAssign.lblFunction.Text = ((string)cmbApplications.SelectedItem) + "." + listFunctions.SelectedItems[0].SubItems[0].Text;
			
			frmAssign.lblParameter.Text = listParametersIn.SelectedItems[0].SubItems[0].Text ;
			frmAssign.lblType.Text = listParametersIn.SelectedItems[0].SubItems[1].Text ;
			frmAssign.lblMandatory.Text = listParametersIn.SelectedItems[0].SubItems[2].Text ;
			frmAssign.sAttribute = listParametersIn.SelectedItems[0].SubItems[3].Text;
			frmAssign.ShowAttributes (vAttributes);

			frmAssign.ShowDialog (this);

			if ( !frmAssign.isCancel ) 
			{
				listParametersIn.SelectedItems[0].SubItems[3].Text = frmAssign.sAttribute;
			}

			//Bring User preferences.

		}

		private void listParametersOut_ItemActivate(object sender, System.EventArgs e)
		{
			AssignParameter frmAssign = new AssignParameter();
			frmAssign.lblFunction.Text = ((string)cmbApplications.SelectedItem) + "." + listFunctions.SelectedItems[0].SubItems[0].Text;
			
			frmAssign.lblParameter.Text = listParametersOut.SelectedItems[0].SubItems[0].Text ;
			frmAssign.lblType.Text = listParametersOut.SelectedItems[0].SubItems[1].Text ;
			frmAssign.lblMandatory.Text = listParametersOut.SelectedItems[0].SubItems[2].Text ;
			frmAssign.sAttribute = listParametersOut.SelectedItems[0].SubItems [3].Text;
			frmAssign.ShowAttributes (vAttributes);

			frmAssign.lblFunction.Text = ((string)cmbApplications.SelectedItem) + "." + listFunctions.SelectedItems[0].SubItems[0].Text;
			
			frmAssign.lblParameter.Text = listParametersOut.SelectedItems[0].SubItems[0].Text ;
			frmAssign.lblType.Text = listParametersOut.SelectedItems[0].SubItems[1].Text ;
			frmAssign.lblMandatory.Text = listParametersOut.SelectedItems[0].SubItems[2].Text ;

			frmAssign.ShowDialog (this);

			if ( !frmAssign.isCancel ) 
			{
				listParametersOut.SelectedItems[0].SubItems[3].Text = frmAssign.sAttribute;
			}

			//Bring User preferences.
		}

		private void button1_Click(object sender, System.EventArgs e)
		{
			this.Close();
		}

		private void button2_Click(object sender, System.EventArgs e)
		{
			xmlApplicationFunction = new XMLApplicationFunction();
			xmlApplicationFunction.Name = listFunctions.SelectedItems[0].SubItems[0].Text;
			xmlApplicationFunction.Application = this.cmbApplications.Text;

			for ( int i=0; i<listParametersIn.Items.Count;i++)
			{
				XMLFormalParameter parameter = new XMLFormalParameter();
				parameter.Name = listParametersIn.Items[i].SubItems[0].Text ;
				parameter.Value = listParametersIn.Items[i].SubItems[3].Text ;

				xmlApplicationFunction.XMLFormalParameters.Add ( parameter);
			}

			for ( int i=0; i<listParametersOut.Items.Count;i++)
			{
				XMLFormalParameter parameter = new XMLFormalParameter();
				parameter.Name = listParametersOut.Items[i].SubItems[0].Text ;

				string sValue = listParametersOut.Items[i].SubItems[3].Text;
				if ( sValue.Substring(0,1) == "[" ) 
				{
					parameter.Bind = sValue.Substring(1, sValue.Length-2);
				}
				parameter.Value =sValue;

				xmlApplicationFunction.XMLApplicationFunctionResult.XMLFormalParameters.Add ( parameter);
			}

			this.Close();
		}

		private void btnSave_Click(object sender, System.EventArgs e)
		{
			xmlApplicationFunction = new XMLApplicationFunction();
			xmlApplicationFunction.Name = listFunctions.SelectedItems[0].SubItems[0].Text;
			xmlApplicationFunction.Application = this.cmbApplications.Text;

			for ( int i=0; i<listParametersIn.Items.Count;i++)
			{
				XMLFormalParameter parameter = new XMLFormalParameter();
				parameter.Name = listParametersIn.Items[i].SubItems[0].Text ;
				parameter.Value = listParametersIn.Items[i].SubItems[3].Text ;
				parameter.Type = listParametersIn.Items[i].SubItems[1].Text ;

				xmlApplicationFunction.XMLFormalParameters.Add ( parameter);
			}

			for ( int i=0; i<listParametersOut.Items.Count;i++)
			{
				XMLFormalParameter parameter = new XMLFormalParameter();
				parameter.Name = listParametersOut.Items[i].SubItems[0].Text ;
				parameter.Type = listParametersOut.Items[i].SubItems[1].Text ;

				string sValue = listParametersOut.Items[i].SubItems[3].Text;
				if ( sValue.Substring(0,1) == "[" ) 
				{
					parameter.Bind = sValue.Substring(1, sValue.Length-2);
				}
				parameter.Value =sValue;

				xmlApplicationFunction.XMLApplicationFunctionResult.XMLFormalParameters.Add ( parameter);
			}

			this.Close();
		}

		private void btnCancel_Click(object sender, System.EventArgs e)
		{
			this.Close();
		}

	}
}
