using System;
using System.Configuration;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using ScenarioFramework.Modules.DM.Application;
using ScenarioFramework.Modules.DM.DataBase;
using ScenarioFramework.Modules.DM.DataModel;

namespace ACEMPortal.Forms
{
	/// <summary>
	/// Summary description for DocumentDetails.
	/// </summary>
	public partial class DocumentDetails : System.Web.UI.Page
	{

		private string sDocumentVersion=string.Empty;
	
		protected void Page_Load(object sender, System.EventArgs e)
		{
            Master.TabName = "Documentazione";
            Master.SubTabName = "Indice Documenti";

			if ( Page.IsPostBack ) 
			{
				sDocumentVersion = (string)Session["DocumentVersion"];
			}
			else
			{
				if ( Request.QueryString["DocumentVersion"] != null )
				{
					Session["DocumentVersion"] = Request.QueryString["DocumentVersion"];
					sDocumentVersion = Request.QueryString["DocumentVersion"];
				}
			}

			if(Request.QueryString["DocumentId"] != null)
			{
				string sDocumentId = Request.QueryString["DocumentId"];
				DocumentManagerDBHelper dmDBHelper = new DocumentManagerDBHelper();
				XMLDocumentInstance document = dmDBHelper.GetDocumentInstance( sDocumentId );

				if ( sDocumentVersion == string.Empty ) 
				{
					sDocumentVersion = document.XMLDocumentVersions.GetLastVersion().Id;
					Session["DocumentVersion"] = sDocumentVersion ;
				}

				if ( document.Type == XMLDocumentBase.BPMNPAGE_TYPE )
				{
					DocumentHelper docHelper=new DocumentHelper (dmDBHelper);
					string sIdFile = docHelper.GetInstanceFileName(document.Id , sDocumentVersion, document.XMLDocumentFile.Id, document.XMLDocumentFile.Type);
					string sFileHtml = docHelper.GetInstanceFileNameWithoutPath (document.Id , sDocumentVersion, document.XMLDocumentFile.Id, "htm");
					string sFileName = docHelper.GetInstanceFileNameWithoutPath(document.Id , sDocumentVersion, document.XMLDocumentFile.Id, document.XMLDocumentFile.Type);

					this.pnlBPMNImage.Visible = true;
					this.bpmnHolder.Visible = true;

					//
					try
					{
						System.IO.File.Copy(sIdFile, ConfigurationSettings.AppSettings["DownloadDirectory"] + sFileName , true);
					}
					catch 
					{}

					string sHtml = "<a href=\"\\ACEMPortal\\ACEM\\DM\\" + sFileHtml + "\" target=\"_new\"><img src=\"\\ACEMPortal\\downloads\\"  + sFileName + "\" width=\"750px\" height=\"530px\" border=2></a>";
					this.bpmnHolder.Controls.Add ( new LiteralControl (sHtml) );
				}

				Session["DocumentInstance"] = document;
			}

		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    

		}
		#endregion
	}
}
