using System;
using System.Configuration;
using System.IO;

namespace DirectoryWatcher
{
    /// <summary>
    /// Represents a specific filesystem event that we should watch for when monitoring changes to
    /// files.
    /// </summary>
    public class EventToWatch : ConfigurationElement
    {
        /// <summary>
        /// Filesystem event that we should watch for.
        /// </summary>
        [ConfigurationProperty("type", IsRequired = true)]
        public WatcherChangeTypes Type
        {
            get
            {
                return (WatcherChangeTypes)base["type"];
            }
        }
    }
}
