using System;
using System.IO;

namespace DirectoryWatcher
{
    /// <summary>
    /// Interface that should be implemented by any class wishing to handle filesystem events.
    /// </summary>
    public interface IFileSystemEventHandler
    {
        /// <summary>
        /// Handler function that is called whenever a filesystem event occurs.
        /// </summary>
        /// <param name="e">
        /// Arguments (file name, directory, event type, etc.) associated with the event.
        /// </param>
        void OnFileSystemEvent(FileSystemEventArgs e);
    }
}
