using System;
using System.Configuration;
using System.Xml;

namespace DirectoryWatcher
{
    /// <summary>
    /// Custom configuration section containing the list of directories that we need to watch for
    /// filesystem changes.
    /// </summary>
    public class WatchInformation : ConfigurationSection
    {
        /// <summary>
        /// Collection of directories that we are to watch for filesystem changes.
        /// </summary>
        [ConfigurationProperty("directoriesToWatch", IsRequired = true)]
        public DirectoryToWatchCollection DirectoriesToWatch
        {
            get
            {
                return (DirectoryToWatchCollection)base["directoriesToWatch"];
            }
        }
    }
}
