using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Diagnostics;
using System.ServiceProcess;
using System.Threading;

namespace Scenario
{
	public class ScenarioWatchDog : System.ServiceProcess.ServiceBase
	{
		private System.Windows.Forms.Timer timerCheckApplications;
		private System.ComponentModel.IContainer components;

		private System.Threading.Timer Chase;

		public ScenarioWatchDog()
		{
			// Chiamata richiesta da Progettazione componenti Windows.Forms.
			InitializeComponent();

			// TODO: aggiungere le eventuali istruzioni di inizializzazione dopo la chiamata a InitComponent.
		}

		// Il punto di ingresso principale del processo
		static void Main()
		{
			System.ServiceProcess.ServiceBase[] ServicesToRun;
	
			// All'interno di uno stesso processo  possibile eseguire pi servizi utente. Per aggiungere
			// un servizio al processo, modificare la riga che segue in modo
			// da creare un secondo oggetto servizio. Ad esempio,
			//
			//   ServicesToRun = New System.ServiceProcess.ServiceBase[] {new Service1(), new MySecondUserService()};
			//
			ServicesToRun = new System.ServiceProcess.ServiceBase[] { new ScenarioWatchDog() };

			System.ServiceProcess.ServiceBase.Run(ServicesToRun);
		}

		/// <summary> 
		/// Metodo necessario per il supporto della finestra di progettazione. Non modificare 
		/// il contenuto del metodo con l'editor di codice.
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			this.timerCheckApplications = new System.Windows.Forms.Timer(this.components);
			// 
			// timerCheckApplications
			// 
			this.timerCheckApplications.Interval = 30000;
			this.timerCheckApplications.Tick += new System.EventHandler(this.timerCheckApplications_Tick);
			// 
			// ScenarioWatchDog
			// 
			this.ServiceName = "ScenarioWatchDog";

		}

		/// <summary>
		/// Pulire le risorse in uso.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		/// <summary>
		/// Effettuare le impostazioni necessarie per il funzionamento del servizio.
		/// </summary>
		protected override void OnStart(string[] args)
		{
			WAPI.Response wapiResponse = new WAPI.Response();
			WAPI.Session.InitSession (ref wapiResponse, "ScenarioWatchDog", 7);

			this.timerCheckApplications.Enabled = true;
			this.timerCheckApplications.Start();
			TimerCallback StartChase = new TimerCallback(timer);
			Chase = new System.Threading.Timer(StartChase , this, 0, 30000);
		}
 
		/// <summary>
		/// Arrestare il servizio.
		/// </summary>
		protected override void OnStop()
		{
			this.timerCheckApplications.Stop();
			this.timerCheckApplications.Enabled = false;
			WAPI.Response wapiResponse = new WAPI.Response();
			WAPI.Session.EndSession (ref wapiResponse);
		}

		private void timerCheckApplications_Tick(object sender, System.EventArgs e)
		{
			WAPI.Response wapiResponse = new WAPI.Response();
			WAPI.Application.RunAllApplications(ref wapiResponse);
		}

		private void timer(object obj)
		{
			WAPI.Response wapiResponse = new WAPI.Response();
			WAPI.Application.RunAllApplications(ref wapiResponse);
		}
	}
}
